<?php
class Gateway_Ipasspaydirect_Model_Payment extends Mage_Payment_Model_Method_Abstract {
	protected $_code = 'ipasspaydirect_payment';
	protected $_formBlockType = 'ipasspaydirect/form';
	protected $_isGateway = false;
	protected $_canAuthorize = true;
	protected $_canCapture = true;
	protected $_canCapturePartial = false;
	protected $_canRefund = false;
	protected $_canVoid = false;
	protected $_canUseInternal = false;
	protected $_canUseCheckout = true;
	protected $_canUseForMultishipping = false;
	public $_cardid;
	public $_ex_month;
	public $_ex_year;
	public $_cvv2;
	protected $_order = null;
	function getCheckout() {
		return Mage::getSingleton('checkout/session');
	}

	function getOrder() {
		if ($this->_order == null) {
			$session = $this->getCheckout();
			$this->_order = Mage::getModel('sales/order');
			$this->_order->loadByIncrementId($session->getLastRealOrderId());
		}
		return $this->_order;
	}

	public function capture(Varien_Object $payment, $amount) {
		$payment->setStatus(self::STATUS_APPROVED)->setLastTransId($this->getTransactionId());
		return $this;
	}

	public function getQuote() {
		return $this->getCheckout()->getQuote();
	}

	// 读获取支付网关地址 get gateway url
	public function getIpasspaydirectUrl() {
		$form_url = $this->getConfigData('paymenturl');
		if ($form_url == "") {
			$form_url = "https://www.ipasspaydirect.biz/index.php/Gateway/securepay";
		}
		return $form_url;
	}

	// 交易异步通知URL. get asyn_url
	protected function getNotifyURL() {
		return Mage::getUrl('ipasspaydirect/payment/notify', array(
			'_secure' => true,
		));
	}

	// 交易即时通知的URL get syn_url
	function getBackUrl() {
		return Mage::getUrl('ipasspaydirect/payment/return', array(
			'_secure' => true,
		));
	}

	function getOrderPlaceRedirectUrl() {
        $_cardid = isset($_POST["cardid"]) ? $_POST["cardid"] : "";
        $_ex_month = isset($_POST["ex_month"]) ? $_POST["ex_month"] : "";
		$_ex_year = isset($_POST["ex_year"]) ? $_POST["ex_year"] : "";
		$_cvv2 = isset($_POST["cvv2"]) ? $_POST["cvv2"] : "";

		$_SESSION['card_no'] = $_cardid;
		$_SESSION['card_ex_month'] = $_ex_month;
		$_SESSION['card_ex_year'] = $_ex_year;
		$_SESSION['card_cvv'] = $_cvv2;

		return Mage::getUrl('ipasspaydirect/payment/redirect');
	}

	public function createFormBlock($name) {
        $block = $this->getLayout()->createBlock('ipasspaydirect/form_payment', $name);
		$block->setMethod($this->_code);
		$block->setPayment($this->getPayment());
		return $block;
	}

	function getStandardCheckoutFormFields() {
		$_order = $this->getOrder();
		if (!($_order instanceof Mage_Sales_Model_Order)) {
			Mage::throwException($this->_getHelper()->__('Cannot retrieve order object'));
		}
		if (!empty($_order)) {
			$billing = $_order->getBillingAddress();
			$shipping = $_order->getShippingAddress();
		} else {
			Mage::throwException($this->_getHelper()->__('This order is empty!'));
		}
		$storeCurrency = Mage::getSingleton('directory/currency')->load($_order->getBaseCurrencyCode());
		$price_currency = Mage::app()->getStore()->getCurrentCurrencyCode(); // 订单标价币种
		$price_amount = sprintf('%.2f', $storeCurrency->convert($_order->getBaseGrandTotal(), $price_currency)); // 交易金额

        $api_secret = $this->getConfigData('md5key');
        $curlPost['merchant_id'] = $this->getConfigData('mid'); //商户id
        $curlPost['app_id'] = $this->getConfigData('appid'); //网站id
        $curlPost['order_no'] = time() . "magento".$_order->getRealOrderId();
        $curlPost['order_currency'] = $price_currency;
        $curlPost['order_amount'] = $price_amount;
        $curlPost['order_items'] = 'goods';

        $curlPost['card_no'] = $_SESSION['card_no'];
        $curlPost['card_ex_year'] = $_SESSION['card_ex_year'];
        $curlPost['card_ex_month'] = $_SESSION['card_ex_month'];
        $curlPost['card_cvv'] =  $_SESSION['card_cvv'];

        $curlPost['source_ip'] = ($this->getIP()=='::1')?'127.0.0.1':$this->getIP();
        $curlPost['source_url'] = $this->curPageURL();
        $curlPost['asyn_notify_url'] = $this->getConfigData('notifyurl')?$this->getConfigData('notifyurl'):$this->curPageURL()."/ipasspaydirect/payment/notify";
        $curlPost['syn_notify_url'] = $this->curPageURL();
        $curlPost['version'] = $this->getConfigData('version');
        $curlPost['signature'] = hash('sha256', $curlPost['merchant_id'] . $curlPost['app_id']  . $curlPost['order_no'] . $curlPost['order_amount'] . $curlPost['order_currency'] . $api_secret);
        //billing
        $curlPost['bill_firstname'] = $billing->getFirstname();
        $curlPost['bill_lastname'] = $billing->getLastname();
        $curlPost['bill_email'] = $billing->getEmail();
        $curlPost['bill_phone'] = $billing->getTelephone() ? $billing->getTelephone() : "--"; // 账单电话;
        $curlPost['bill_country'] = $billing->getCountryModel()->getIso2Code(); // 账单国家, 转化为2位国家代码;
        $curlPost['bill_state'] = $billing->getRegionCode() ? $billing->getRegionCode() : "--"; // 账单地区;
        $curlPost['bill_city'] = $billing->getCity(); // 账单城市
        $curlPost['bill_street'] = $billing->getStreet(1); // 账单地址;
        $curlPost['bill_zip'] = $billing->getPostcode() ? $billing->getPostcode() : "--"; // 账单邮编
        //shipping
        $curlPost['ship_firstname'] = $shipping->getFirstname();
        $curlPost['ship_lastname'] = $shipping->getLastname();
        $curlPost['ship_email'] = $shipping->getEmail();
        $curlPost['ship_phone'] = $shipping->getTelephone() ? $billing->getTelephone() : "--";
        $curlPost['ship_country'] = $shipping->getCountryModel()->getIso2Code();
        $curlPost['ship_state'] = $shipping->getRegionCode() ? $billing->getRegionCode() : "--";
        $curlPost['ship_city'] = $shipping->getCity();
        $curlPost['ship_street'] = $shipping->getStreet(1);
        $curlPost['ship_zip'] = $shipping->getPostcode() ? $billing->getPostcode() : "--";
        $curlPost['custom_data'] = $_order->getRealOrderId();
        $curlPost['lang'] = 'en-us'; //zh-cn en-us
        //echo json_encode($curlPost);exit;
        //$response = $this->curlSend($this->getConfigData('paymenturl'),$curlPost,1);
        //echo $response;exit;

        /*
        $result = json_decode($response,true);

        if($result["data"]["pay_url"] != '') {
            //3D channel payment
            $redirect_url = urldecode($result["data"]["pay_url"]);
            Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
            $order->addStatusToHistory(
                $model->getConfigData('order_status_payment_pending'),
                Mage::helper('ipasspaydirect')->__('Payment pending!')
            );
            //$order->setState($model->getConfigData('order_status_payment_success'), true);
            $order->save();
            //var_dump($_POST);
            //exit;
            //$this->_redirect('checkout/onepage/success');
            header("Location: $redirect_url");
            exit;

        } else {  // 2D channel payment
            if ($result['errcode'] != 0) {
                Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $result['errmsg']));
                Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $result['errmsg']));
                Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $result['errmsg']));
                $order->addStatusToHistory(
                    $model->getConfigData('order_status'),
                    Mage::helper('ipasspaydirect')->__('Payment failed!')
                );
                $order->save();
                $this->_redirect('checkout/onepage/failure');
                //throw new Exception($result['errmsg']);
            } else {
                switch ($result['data']['order_status']) {
                    case 2://成功
                    case 4://已授权
                        Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
                        $order->addStatusToHistory(
                            $model->getConfigData('order_status_payment_success'),
                            Mage::helper('ipasspaydirect')->__('Payment succeed!')
                        );
                        //$order->setState($model->getConfigData('order_status_payment_success'), true);
                        $order->save();
                        //var_dump($_POST);
                        //exit;
                        $this->_redirect('checkout/onepage/success');
                        break;
                    case 3: //失败
                        //throw new Exception($result['data']['info']);
                        Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $result['data']['info']));
                        Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $result['data']['info']));
                        Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $result['data']['info']));
                        $order->addStatusToHistory(
                            $model->getConfigData('order_status'),
                            Mage::helper('ipasspaydirect')->__('Payment failed!')
                        );
                        $order->save();
                        $this->_redirect('checkout/onepage/failure');
                        break;
                    default: //未知
                        break;
                }
            }
        }
        */

        /*
        $basicinfo = $curlPost;
		$str = "";
		foreach ($basicinfo as $strkey => $value) {
			if (is_array($value)) {
				foreach ($value as $values => $strvalue) {
					$str .= $strkey . "=" . urlencode($strvalue) . "&";
				}
			} else {
				$str .= $strkey . "=" . urlencode($value) . "&";
			}
		}
		$_parameter = rtrim($str, '&');
		return $_parameter;
        */

        return $curlPost;

	}

	// 获取客户端的ip
	function getIPaddress() {
		$IPaddress = '';
		if (isset($_SERVER)) {
			if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])) {
				$IPaddress = $_SERVER["HTTP_X_FORWARDED_FOR"];
			} else if (isset($_SERVER["HTTP_CLIENT_IP"])) {
				$IPaddress = $_SERVER["HTTP_CLIENT_IP"];
			} else {
				$IPaddress = $_SERVER["REMOTE_ADDR"];
			}
		} else {
			if (getenv("HTTP_X_FORWARDED_FOR")) {
				$IPaddress = getenv("HTTP_X_FORWARDED_FOR");
			} else if (getenv("HTTP_CLIENT_IP")) {
				$IPaddress = getenv("HTTP_CLIENT_IP");
			} else {
				$IPaddress = getenv("REMOTE_ADDR");
			}
		}
		$ips = explode(",", $IPaddress);
		return $ips[0];
	}

    function getIP() {
        static $realip;
        if (isset($_SERVER)){
            if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])){
                $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
            } else if (isset($_SERVER["HTTP_CLIENT_IP"])) {
                $realip = $_SERVER["HTTP_CLIENT_IP"];
            } else {
                $realip = $_SERVER["REMOTE_ADDR"];
            }
        } else {
            if (getenv("HTTP_X_FORWARDED_FOR")){
                $realip = getenv("HTTP_X_FORWARDED_FOR");
            } else if (getenv("HTTP_CLIENT_IP")) {
                $realip = getenv("HTTP_CLIENT_IP");
            } else {
                $realip = getenv("REMOTE_ADDR");
            }
        }
        return $realip;
    }

    function curPageURL() {
        $pageURL = 'http';

        if ($_SERVER["HTTPS"] == "on")
        {
            $pageURL .= "s";
        }
        $pageURL .= "://";

        if ($_SERVER["SERVER_PORT"] != "80")
        {
            $pageURL .= $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"];
        }
        else
        {
            $pageURL .= $_SERVER["SERVER_NAME"];
        }
        return $pageURL;
    }

     function curlSend($process_gateway, $data_arr, $type = 1) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $process_gateway);
        curl_setopt($ch, CURLOPT_POST, $type);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data_arr));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }

}
