<?php

class Gateway_Ipasspaydirect_PaymentController extends Mage_Core_Controller_Front_Action {
	protected $_order;
	protected $_orderId;
	protected $_bankMsg;
	protected function _expireAjax() {
		if (!Mage::getSingleton('checkout/session')->getQuote()->hasItems()) {
			$this->getResponse()->setHeader('HTTP/1.1', '403 Session Expired');
			exit();
		}
	}
	public function getOrder() {
		if ($this->_order == null) {
			$session = Mage::getSingleton('checkout/session');
			$this->_order = Mage::getModel('sales/order');
			$this->_order->loadByIncrementId($session->getLastRealOrderId());
		}
		return $this->_order;
	}
	public function getCheckout() {
		return Mage::getSingleton('checkout/session');
	}
	public function redirectAction() {
	    $order = $this->getOrder();
		$session = $this->getCheckout();
		$session->setIpasspaydirectPaymentQuoteId($session->getQuoteId());
		$model = Mage::getModel('ipasspaydirect/payment');
		$order = $this->getOrder();

		if (!$order->getId()) {
			$this->norouteAction();
			return;
		}
		$order->addStatusToHistory($order->getStatus(), Mage::helper('ipasspaydirect')->__('Customer was redirected to ipasspaydirect'), false);
		$order->save();
		$this->loadLayout();
		$this->getLayout()->getBlock('root')->setTemplate('page/1column.phtml');
		$this->getLayout()->getBlock('content')->append($this->getLayout()->createBlock('ipasspaydirect/redirect'));
		$this->renderLayout();
		$session->unsQuoteId();

	}
	public function returnAction() {
		if (empty($_POST)) {
			$this->_redirect('checkout/onepage/failure');
			return false;
		}
		$model = Mage::getModel('ipasspaydirect/payment');
		//echo json_encode($_POST);exit;
		if ($_POST['status'] == 'empty') {
            Mage::getSingleton("customer/session")->addError($this->__($_POST['info']));
			Mage::getSingleton("core/session")->addError($this->__($_POST['info']));
			Mage::getSingleton("checkout/session")->addError($this->__($_POST['info']));
			$this->_redirect('sales/order/reorder/order_id/' . $_POST['oid1']);
			return false;
		} elseif ($_POST['status'] == 0) {
            $order_status = $_POST['order_status']; //订单状态
            $order_no = $_POST['order_no']; //商户的订单号
            $gateway_order_no = $_POST['gateway_order_no']; //ipasspaydirect平台的订单号
            $order_amount = $_POST['order_amount'];
            $order_currency = $_POST['order_currency']; //交易货币
			$notification_url = $_POST['notification_url']; //网站即时通知URL)
			$info = $_POST['info']; //此时"info"字段的值为该笔交易失败的原因说明
            $signature = $_POST['signature'];
			$mid = $model->getConfigData('mid');
			$app_id = $model->getConfigData('appid');
			$api_key = $model->getConfigData('md5key');
            $version = $model->getConfigData('version');

            $getsignature = hash('sha256', $mid.$app_id.$order_no.$gateway_order_no.$order_currency.$order_amount.$order_status.$api_key);

            if ($getsignature != $signature) {
				Mage::getSingleton("customer/session")->addError($this->__('invalid hash info'));
				Mage::getSingleton("core/session")->addError($this->__('invalid hash info'));
				Mage::getSingleton("checkout/session")->addError($this->__('invalid hash info'));
				$this->_redirect('sales/order/reorder/order_id/' . $_POST['oid1']);
				return false;
			}
			$order = Mage::getModel('sales/order')->loadByIncrementId($_POST['oid1']);

			switch ($order_status) {
			    case 2: // success
                    Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
                    $order->addStatusToHistory(
                        $model->getConfigData('order_status_payment_success'),
                        Mage::helper('ipasspaydirect')->__('Payment succeed!')
                    );
                    //$order->setState($model->getConfigData('order_status_payment_success'), true);
                    $order->save();
                    //var_dump($_POST);
                    //exit;
                    $this->_redirect('checkout/onepage/success');
                    break;
                case 1: // pending
                Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
                $order->addStatusToHistory(
                    $model->getConfigData('order_status_payment_pending'),
                    Mage::helper('ipasspaydirect')->__('Payment pending!')
                );
                //$order->setState($model->getConfigData('order_status_payment_success'), true);
                $order->save();
                //var_dump($_POST);
                //exit;
                $this->_redirect('checkout/onepage/success');
                break;
                case 4: // authorized
                Mage::getSingleton('core/session')->addSuccess($this->__('Payment success'));
                $order->addStatusToHistory(
                    $model->getConfigData('order_status_payment_authroized'),
                    Mage::helper('ipasspaydirect')->__('Payment authroized!')
                );
                //$order->setState($model->getConfigData('order_status_payment_success'), true);
                $order->save();
                //var_dump($_POST);
                //exit;
                $this->_redirect('checkout/onepage/success');
                break;
			    case 6: // declined
				// error message
				Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				$order->addStatusToHistory(
					$model->getConfigData('order_status'),
					Mage::helper('ipasspaydirect')->__('Payment failed!')
				);
				$order->save();
				$this->_redirect('checkout/onepage/failure');
				break;
			    default:
				// error message
				Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $info));
				$this->_redirect('checkout/onepage/failure');
			}

		} else {
			Mage::getSingleton("customer/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $_POST['info']));
			Mage::getSingleton("core/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $_POST['info']));
			Mage::getSingleton("checkout/session")->addError($this->__("Payment failure.&nbsp;&nbsp;" . $_POST['info']));
			$this->_redirect('checkout/onepage/failure');
			return false;
		}

	}
	public function notifyAction() {
	    // asynchronous notification

		$model = Mage::getModel('ipasspaydirect/payment');

        $order_id = $_REQUEST['custom_data'];
        $order_no = $_REQUEST['order_no'];
        $gateway_order_no = $_REQUEST['gateway_order_no'];
        $order_currency = $_REQUEST['order_currency'];
        $order_amount = $_REQUEST['order_amount'];
        $order_status = $_REQUEST['order_status'];
        $order_signature = $_REQUEST['signature'];
        $message = '';


        $mid = $model->getConfigData('mid');
        $app_id = $model->getConfigData('appid');
        $api_secret = $model->getConfigData('md5key');

        $signature = hash('sha256', $mid.$app_id.$order_no.
            $gateway_order_no.$order_currency.$order_amount.
            $order_status.$api_secret);

        if ($signature == $order_signature) {
            $order = Mage::getModel('sales/order')->loadByIncrementId($order_id);
            if ($order_status == 2) { // 支付成功
                $order->addStatusToHistory($model->getConfigData('order_status_payment_success'), Mage::helper('ipasspaydirect')->__('Payment Success!'), true);
                $order->save();
                //$this->_redirect('checkout/onepage/success');
            } elseif ($order_status == 3) { // 失败
                $_SESSION['message'] = 'Decline';
                $order->addStatusToHistory($model->getConfigData('order_status'), Mage::helper('ipasspaydirect')->__('Payment failure!'), true);
                $order->save();
                //$this->_redirect('checkout/onepage/failure');
            } else {
                //do nothing.
            }

            $res = array(
                'errcode' => '0',
                'errmsg' => 'success',
            );
        } else {
            $res = array(
                'errcode' => '1',
                'errmsg' => 'failure',
            );
        }

        echo json_encode($res);
        exit;

	}

	protected function saveInvoice(Mage_Sales_Model_Order $order) {
		if ($order->canInvoice()) {
			$convertor = Mage::getModel('sales/convert_order');
			$invoice = $convertor->toInvoice($order);
			foreach ($order->getAllItems() as $orderItem) {
				if (!$orderItem->getQtyToInvoice()) {
					continue;
				}
				$item = $convertor->itemToInvoiceItem($orderItem);
				$item->setQty($orderItem->getQtyToInvoice());
				$invoice->addItem($item);
			}
			$invoice->collectTotals();
			$invoice->register()->capture();
			Mage::getModel('core/resource_transaction')->addObject($invoice)->addObject($invoice->getOrder())->save();
			return true;
		}
		return false;
	}
}

